import { MyPmstypeModel, PmstypeModel } from "./pmstype.model";

export interface PmsEaluationFactors1Model {
    pmsType: PmstypeModel
    companyId: string
    pmsScore: number
}

export class MyPmsEaluationFactors1Model implements PmsEaluationFactors1Model {
    pmsType: PmstypeModel
    companyId: string
    pmsScore: number
    constructor(data?: Partial<PmsEaluationFactors1Model>) {
        this.pmsType = new MyPmstypeModel(data?.pmsType)
        this.companyId = data?.companyId || ""
        this.pmsScore = data?.pmsScore ?? 0
    }
}

